// ======================================================================
//
// Gl_dd.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef GL_DD_H
#define GL_DD_H

// ======================================================================

#include "Gl_abstract.h"
#include "DirectDraw.h"

// ======================================================================

class GL_dd : public GL_abstract
{
private:

	// disable copy constructor and assignment operator
	GL_dd(const GL_dd &);
	GL_dd &operator =(const GL_dd &);

protected:

	static void *buffer;
	static int   pitch;

protected:

	static bool  lockDD(bool backBuffer=true);
	static void  unlockDD(void);
	static bool  isLockedDD(void);
	static void  createSurfaces(const GL_input *input, GL_output *output);

public:
	
	static void   *getBuffer(void);
	static int     getPitch(void);

public:

	GL_dd(void);
	virtual ~GL_dd(void);

	// initialize
	virtual bool  init(const GL_input *input, GL_output *output, const DirectDraw::Driver *driver=NULL);

	virtual void  setDrawWindow(HWND newDrawWindow);

	// access functions	
	virtual void  unlock(bool display);
	virtual bool  gdiVisible(void);

	// movie primitive
	virtual void  movie(const uv_instance *uv);
	virtual bool  specialEffect(int id, void *data);
};

// ======================================================================

inline void *GL_dd::getBuffer(void)
{
	return buffer;
}

// ----------------------------------------------------------------------

inline int GL_dd::getPitch(void)
{
	return pitch;
}

// ----------------------------------------------------------------------

inline bool GL_dd::isLockedDD(void)
{
	return (buffer != NULL);
}

// ======================================================================

#endif
